#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 SaddleBrown
#property indicator_color2 SaddleBrown
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width3 3
#property indicator_width4 3
#property indicator_color5 CLR_NONE
#property indicator_color6 CLR_NONE
#property indicator_color7 CLR_NONE
#property indicator_color8 CLR_NONE

extern int IPeriod = 18;
double gda92[];
double gda_96[];
double gda_100[];
double gda_104[];
double gda_108[];
double gda_112[];
double gda_116[];
double gda_120[];

int init() {
   SetIndexBuffer(0, gda92);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1, gda_96);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2, gda_100);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3, gda_104);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4, gda_108);
   SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexBuffer(5, gda_112);
   SetIndexStyle(5, DRAW_HISTOGRAM);
   SetIndexBuffer(6, gda_116);
   SetIndexStyle(6, DRAW_HISTOGRAM);
   SetIndexBuffer(7, gda_120);
   SetIndexStyle(7, DRAW_HISTOGRAM);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double ld_12;
   double ld_20;
   int li_0 = IndicatorCounted();
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   int li_8 = Bars - li_0;
   for (int li_4 = li_8; li_4 >= 0; li_4--) {
      //ld_12 = iCustom(Symbol(), 0, "erX", erX, 0, li_4);
      //ld_20 = iCustom(Symbol(), 0, "erX", erX, 0, li_4 + 1);
      
      double rangeup = iCustom(NULL, 0, "RangeOscillator~" , IPeriod, 0, li_4);
      double rangedown = iCustom(NULL, 0, "RangeOscillator~" , IPeriod, 0, li_4 + 1);
      double level80 = -82;

      gda92[li_4] = EMPTY_VALUE;
      gda_96[li_4] = EMPTY_VALUE;
      gda_100[li_4] = EMPTY_VALUE;
      gda_104[li_4] = EMPTY_VALUE;
      gda_108[li_4] = EMPTY_VALUE;
      gda_112[li_4] = EMPTY_VALUE;
      gda_116[li_4] = EMPTY_VALUE;
      gda_120[li_4] = EMPTY_VALUE;
      if (rangedown<182 && rangeup>182) {
         gda92[li_4] = High[li_4];
         gda_96[li_4] = Low[li_4];
         if (Close[li_4] > Open[li_4]) {
            gda_100[li_4] = Close[li_4];
            gda_104[li_4] = Open[li_4];
         } else {
            gda_104[li_4] = Close[li_4];
            gda_100[li_4] = Open[li_4];
         }
      }
      if (rangedown>level80 && rangeup<level80) {
         gda92[li_4] = Low[li_4];
         gda_96[li_4] = High[li_4];
         if (Close[li_4] < Open[li_4]) {
            gda_100[li_4] = Close[li_4];
            gda_104[li_4] = Open[li_4];
         } else {
            gda_104[li_4] = Close[li_4];
            gda_100[li_4] = Open[li_4];
         }
      }
      if (ld_12 == ld_20) {
         gda_108[li_4] = Low[li_4];
         gda_112[li_4] = High[li_4];
         gda_116[li_4] = Open[li_4];
         gda_120[li_4] = Close[li_4];
      }
   }
   return (0);
}